<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_RatePrice ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_RatePrice extends AbstractStructArrayBase
{
    /**
     * The RatePrice
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_RatePrice[]
     */
    public $RatePrice;
    /**
     * Constructor method for ArrayOfJPSOAP_RatePrice
     * @uses ArrayOfJPSOAP_RatePrice::setRatePrice()
     * @param \StructType\JPSOAP_RatePrice[] $ratePrice
     */
    public function __construct(array $ratePrice = array())
    {
        $this
            ->setRatePrice($ratePrice);
    }
    /**
     * Get RatePrice value
     * @return \StructType\JPSOAP_RatePrice[]|null
     */
    public function getRatePrice()
    {
        return $this->RatePrice;
    }
    /**
     * Set RatePrice value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_RatePrice[] $ratePrice
     * @return \ArrayType\ArrayOfJPSOAP_RatePrice
     */
    public function setRatePrice(array $ratePrice = array())
    {
        foreach ($ratePrice as $arrayOfJPSOAP_RatePriceRatePriceItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_RatePriceRatePriceItem instanceof \StructType\JPSOAP_RatePrice) {
                throw new \InvalidArgumentException(sprintf('The RatePrice property can only contain items of \StructType\JPSOAP_RatePrice, "%s" given', is_object($arrayOfJPSOAP_RatePriceRatePriceItem) ? get_class($arrayOfJPSOAP_RatePriceRatePriceItem) : gettype($arrayOfJPSOAP_RatePriceRatePriceItem)), __LINE__);
            }
        }
        $this->RatePrice = $ratePrice;
        return $this;
    }
    /**
     * Add item to RatePrice value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_RatePrice $item
     * @return \ArrayType\ArrayOfJPSOAP_RatePrice
     */
    public function addToRatePrice(\StructType\JPSOAP_RatePrice $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_RatePrice) {
            throw new \InvalidArgumentException(sprintf('The RatePrice property can only contain items of \StructType\JPSOAP_RatePrice, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->RatePrice[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_RatePrice|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_RatePrice|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_RatePrice|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_RatePrice|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_RatePrice|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RatePrice
     */
    public function getAttributeName()
    {
        return 'RatePrice';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJPSOAP_RatePrice
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
